//#define _SUPPRESS_PLIB_WARNING

#include <plib.h>
#include "GenericTypeDefs.h"
#include "other.h"
#include <limits.h>
#include <math.h>

volatile unsigned long tmp;

int val1,val2,val3,val4;
int inc1, inc2, inc3, inc4;
float freq1,freq2,freq3,freq4;
float len1, len2, len3,len4;

unsigned int get_adc (unsigned char chnl);
int get_div (float freq);

extern int sinetable[SINTABLE_LEN];
BOOL toggleData1 = TRUE;
BOOL toggleData2 = TRUE;

unsigned int adc_val1,adc_val2,adc_val3,adc_val4;
int offset,oversample,i;


int main(void)

{
	AD1CON1bits.ON  = 1;
    AD1CON1bits.ASAM  = 1;
    AD1CON3bits.ADRC  = 1;
    AD1CON3bits.SAMC  = 0x10;
    AD1CHS = (16<<0x0B);
	main_init();
	IEC1bits.SPI1TXIE=1;
	IEC1bits.SPI2TXIE=1;
	inc1 = get_div(65.41*2.0);
	inc2 = get_div(98.0*2.0);
	inc3 = get_div(146.83*2.0);
	inc4 = get_div(220.0*2.0);
	offset  = 150;
	oversample = 200;
	while(1)
		{
        //fugly repeated code, I should define proper structured and do it in loop. Anyway, this also works.
		adc_val1 = 0;
		adc_val2 = 0;
		adc_val3 = 0;
		adc_val4 = 0;
		for (i=0;i<oversample;i++)
			adc_val1 = adc_val1 + get_adc(0)+offset;
		for (i=0;i<oversample;i++)
			adc_val2 = adc_val2 + get_adc(1)+offset;
		for (i=0;i<oversample;i++)
			adc_val3 = adc_val3 + get_adc(4)+offset;
		for (i=0;i<oversample;i++)
			adc_val4 = adc_val4 + get_adc(5)+offset;
		len1 = adc_val1 / ((570.0+offset)*oversample);
		len2 = adc_val2 / ((570.0+offset)*oversample);
		len3 = adc_val3 / ((570.0+offset)*oversample);
		len4 = adc_val4 / ((570.0+offset)*oversample);
		freq1 = 220.0 / len1;
		freq2 = 146.0 / len2;	//no need for exact frequencies, will be fine tuned anyway
		freq3 = 98.0 / len3;
		freq4 = 65.0 / len4;
		inc1 = get_div(freq1);
		inc2 = get_div(freq2);
		inc3 = get_div(freq3);
		inc4 = get_div(freq4);
		
		}
}


int get_div (float freq)
	{
	float temp;
	temp = 96000.0/ freq;
	temp = 8000000 / temp;
	return temp;
	}

unsigned int get_adc (unsigned char chnl)
    {
    unsigned long tmp;
    tmp = chnl;
    tmp = tmp << 16;
    AD1CHS = (tmp);
    AD1CON1CLR = 0x0002;
    while (!(AD1CON1&0x0001));
    return ADC1BUF0;
    }



/* SPI1 ISR */
void __attribute__((vector(_SPI_1_VECTOR), interrupt(ipl4))) SPI1InterruptHandler(void)
{	
int val;
IFS1bits.SPI1TXIF = 0;
if (SPI1STATbits.SPIROV) SPI1STATbits.SPIROV=0;
tmp = SPI1BUF;
if (toggleData1==0)
	{
	SPI1BUF = val1;
	val1 = val1 + inc2;
	if (val1>8000000) val1 = 0;
	}
else
	{
	SPI1BUF = val2;
	val2 = val2 + inc1;
	if (val2>8000000) val2 = 0;
	}
toggleData1 =! toggleData1;
IFS1bits.SPI1TXIF = 0;
}

/* SPI1 ISR */
void __attribute__((vector(_SPI_2_VECTOR), interrupt(ipl4))) SPI2InterruptHandler(void)
{	
int val;
IFS1bits.SPI2TXIF = 0;
if (SPI2STATbits.SPIROV) SPI2STATbits.SPIROV=0;

tmp = SPI2BUF;
if (toggleData2==0)
	{
	SPI2BUF = val3;
	val3 = val3 + inc4;
	if (val3>8000000) val3 = 0;
	}
else
	{
	SPI2BUF = val4;
	val4 = val4 + inc3;
	if (val4>8000000) val4 = 0;
	}
toggleData2 =! toggleData2;
IFS1bits.SPI2TXIF = 0;
}
