 #include "fftc.h" // pre-computed coefficients
 #include <limits.h>
 #include <math.h>
#include "other.h"
#include <plib.h>
//#include "GenericTypeDefs.h"

/*
//Configuration bit pragmas.
#pragma config FPLLMUL = MUL_20, FPLLIDIV = DIV_2, FPLLODIV = DIV_2
#pragma config POSCMOD = HS, FNOSC = PRIPLL, FPBDIV = DIV_1, FSOSCEN = OFF
#pragma config UPLLEN = ON, UPLLIDIV = DIV_2, FVBUSONIO = OFF, FUSBIDIO = OFF
#pragma config FWDTEN = OFF, JTAGEN = OFF    
#pragma config IESO = OFF, IOL1WAY = ON, PMDL1WAY = ON, OSCIOFNC = OFF            
#pragma config ICESEL = ICS_PGx1  
*/
/*
#pragma config FPLLMUL = MUL_20, FPLLIDIV = DIV_2, FPLLODIV = DIV_2
#pragma config POSCMOD = HS, FNOSC = PRIPLL, FPBDIV = DIV_1, FSOSCEN = OFF
#pragma config FVBUSONIO = OFF, FUSBIDIO = OFF
#pragma config FWDTEN = OFF, JTAGEN = OFF    
#pragma config IESO = OFF, IOL1WAY = ON, PMDL1WAY = ON, OSCIOFNC = OFF            
#pragma config ICESEL = ICS_PGx1 
*/

// DEVCFG3
// USERID = No Setting
#pragma config PMDL1WAY = ON            // Peripheral Module Disable Configuration (Allow only one reconfiguration)
#pragma config IOL1WAY = ON             // Peripheral Pin Select Configuration (Allow only one reconfiguration)

// DEVCFG2
#pragma config FPLLIDIV = DIV_2         // PLL Input Divider (2x Divider)
#pragma config FPLLMUL = MUL_20         // PLL Multiplier (20x Multiplier)
#pragma config FPLLODIV = DIV_2         // System PLL Output Clock Divider (PLL Divide by 2)

// DEVCFG1
#pragma config FNOSC = PRIPLL           // Oscillator Selection Bits (Primary Osc w/PLL (XT+,HS+,EC+PLL))
#pragma config FSOSCEN = ON             // Secondary Oscillator Enable (Enabled)
#pragma config IESO = ON                // Internal/External Switch Over (Enabled)
#pragma config POSCMOD = HS             // Primary Oscillator Configuration (HS osc mode)
#pragma config OSCIOFNC = OFF           // CLKO Output Signal Active on the OSCO Pin (Disabled)
#pragma config FPBDIV = DIV_1           // Peripheral Clock Divisor (Pb_Clk is Sys_Clk/1)
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor Selection (Clock Switch Disable, FSCM Disabled)
#pragma config WDTPS = PS1048576        // Watchdog Timer Postscaler (1:1048576)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable (Watchdog Timer is in Non-Window Mode)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable (WDT Disabled (SWDTEN Bit Controls))
#pragma config FWDTWINSZ = WINSZ_25     // Watchdog Timer Window Size (Window Size is 25%)

// DEVCFG0
#pragma config JTAGEN = OFF             // JTAG Enable (JTAG Disabled)
#pragma config ICESEL = ICS_PGx1        // ICE/ICD Comm Channel Select (Communicate on PGEC1/PGED1)
#pragma config PWP = OFF                // Program Flash Write Protect (Disable)
#pragma config BWP = OFF                // Boot Flash Write Protect bit (Protection Disabled)
#pragma config CP = OFF                 // Code Protect (Protection Disabled)

int sinetable[SINTABLE_LEN] = 
{
0,51472,102941,154407,205867,257319,308761,360192,411609,463011,514396,565761,617104,668425,719720,770988, 
822227,873436,924611,975751,1026855,1077920,1128945,1179927,1230864,1281756,1332599,1383392,1434132,1484819,1535450,1586023,
1636536,1686988,1737376,1787699,1837954,1888141,1938256,1988298,2038265,2088156,2137968,2187700,2237349,2286914,2336392,2385783,
2435084,2484294,2533410,2582430,2631353,2680177,2728901,2777521,2826037,2874446,2922748,2970939,3019018,3066984,3114834,3162567,
3210181,3257674,3305045,3352291,3399411,3446402,3493264,3539995,3586592,3633054,3679380,3725567,3771613,3817518,3863279,3908894,
3954362,3999682,4044851,4089867,4134730,4179437,4223986,4268377,4312606,4356674,4400577,4444315,4487885,4531287,4574518,4617576,
4660461,4703170,4745702,4788056,4830229,4872221,4914029,4955652,4997088,5038336,5079395,5120262,5160937,5201417,5241701,5281788,
5321677,5361364,5400850,5440133,5479211,5518082,5556746,5595201,5633445,5671477,5709295,5746898,5784285,5821455,5858405,5895134,
5931642,5967926,6003985,6039819,6075425,6110802,6145949,6180865,6215549,6249998,6284212,6318189,6351928,6385428,6418688,6451706,
6484482,6517013,6549299,6581338,6613129,6644672,6675964,6707005,6737793,6768328,6798608,6828632,6858399,6887907,6917156,6946145,
6974873,7003337,7031538,7059475,7087145,7114549,7141685,7168552,7195149,7221475,7247530,7273311,7298819,7324052,7349009,7373689,
7398092,7422216,7446061,7469625,7492909,7515910,7538628,7561062,7583212,7605076,7626654,7647945,7668947,7689661,7710086,7730220,
7750063,7769615,7788874,7807839,7826511,7844888,7862970,7880755,7898244,7915436,7932329,7948924,7965220,7981215,7996911,8012305,
8027397,8042188,8056675,8070859,8084740,8098316,8111587,8124552,8137212,8149565,8161612,8173351,8184783,8195906,8206721,8217227,
8227423,8237310,8246887,8256153,8265108,8273752,8282085,8290105,8297814,8305210,8312294,8319064,8325522,8331666,8337496,8343012,
8348215,8353102,8357676,8361935,8365879,8369508,8372822,8375820,8378504,8380871,8382924,8384660,8386082,8387187,8387976,8388450,
8388608,8388450,8387976,8387187,8386082,8384660,8382924,8380871,8378504,8375820,8372822,8369508,8365879,8361935,8357676,8353102,
8348215,8343012,8337496,8331666,8325522,8319064,8312294,8305210,8297814,8290105,8282085,8273752,8265108,8256153,8246887,8237310,
8227423,8217227,8206721,8195906,8184783,8173351,8161612,8149565,8137212,8124552,8111587,8098316,8084740,8070859,8056675,8042188,
8027397,8012305,7996911,7981215,7965220,7948924,7932329,7915436,7898244,7880755,7862970,7844888,7826511,7807839,7788874,7769615,
7750063,7730220,7710086,7689661,7668947,7647945,7626654,7605076,7583212,7561062,7538628,7515910,7492909,7469625,7446061,7422216,
7398092,7373689,7349009,7324052,7298819,7273311,7247530,7221475,7195149,7168552,7141685,7114549,7087145,7059475,7031538,7003337,
6974873,6946145,6917156,6887907,6858399,6828632,6798608,6768328,6737793,6707005,6675964,6644672,6613129,6581338,6549299,6517013,
6484482,6451706,6418688,6385428,6351928,6318189,6284212,6249998,6215549,6180865,6145949,6110802,6075425,6039819,6003985,5967926,
5931642,5895134,5858405,5821455,5784285,5746898,5709295,5671477,5633445,5595201,5556746,5518082,5479211,5440133,5400850,5361364,
5321677,5281788,5241701,5201417,5160937,5120262,5079395,5038336,4997088,4955652,4914029,4872221,4830229,4788056,4745702,4703170,
4660461,4617576,4574518,4531287,4487885,4444315,4400577,4356674,4312606,4268377,4223986,4179437,4134730,4089867,4044851,3999682,
3954362,3908894,3863279,3817518,3771613,3725567,3679380,3633054,3586592,3539995,3493264,3446402,3399411,3352291,3305045,3257674,
3210181,3162567,3114834,3066984,3019018,2970939,2922748,2874446,2826037,2777521,2728901,2680177,2631353,2582430,2533410,2484294,
2435084,2385783,2336392,2286914,2237349,2187700,2137968,2088156,2038265,1988298,1938256,1888141,1837954,1787699,1737376,1686988,
1636536,1586023,1535450,1484819,1434132,1383392,1332599,1281756,1230864,1179927,1128945,1077920,1026855,975751,924611,873436,
822227,770988,719720,668425,617104,565761,514396,463011,411609,360192,308761,257319,205867,154407,102941,51472, 
};



void main_init (void)
{

volatile unsigned long tmp;
	UINT spi_con1 = 0, spi_con2 = 0;
	UINT baud_rate = SAMPLE_RATE*64;
	UINT mclk = SAMPLE_RATE*256;

	//Congigure MIPS, Prefetch Cache module.
	SYSTEMConfig(SYS_FREQ, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);
	INTEnableSystemMultiVectoredInt();


	//Configure the direction of used pins and 
	//configure as digital pins.
	PORTSetPinsDigitalOut(IOPORT_B, BIT_15);
	PORTSetPinsDigitalOut(IOPORT_B, BIT_13);
	PORTSetPinsDigitalOut(IOPORT_B, BIT_14);
	PORTSetPinsDigitalOut(IOPORT_B, BIT_11);
	PORTSetPinsDigitalOut(IOPORT_B, BIT_10);
	PORTSetPinsDigitalIn(IOPORT_B, BIT_8);
	PORTSetPinsDigitalOut(IOPORT_B, BIT_4);
	PORTSetPinsDigitalOut(IOPORT_A, BIT_4);
	
	PPSOutput(3, RPB6, REFCLKO);	//REFCLK0:
	PPSOutput(2, RPB11, SDO1);		//SDO:
	PPSOutput(1, RPB7, SS1);		//SS:

	PPSOutput(3, RPB13, SDO2);		//SDO:
	PPSOutput(4, RPB10, SS2);		//SS:


	//Configure Reference Clock Output to 12.288MHz.
	mOSCREFOTRIMSet(REFTRIM);	
	OSCREFConfig(OSC_REFOCON_USBPLL, 				//USB-PLL clock output used as REFCLKO source
				 OSC_REFOCON_OE | OSC_REFOCON_ON, 	//Enable and turn on the REFCLKO
				 RODIV_V);
	
	//Configure SPI in I2S mode with 24-bit stereo audio. 	
    spi_con1 = 	SPI_OPEN_MSTEN    	|  	//Master mode enable 
				SPI_OPEN_SSEN     	|  	//Enable slave select function
				SPI_OPEN_CKP_HIGH 	|  	//Clock polarity Idle High Actie Low
				SPI_OPEN_MODE16		|	//Data mode: 24b
				SPI_OPEN_MODE32		|	//Data mode: 24b
				SPI_OPEN_MCLKSEL	|	//Clock selected is reference clock
				SPI_OPEN_FSP_HIGH;   	//Frame Sync Pulse is active high

    spi_con2 = 	SPI_OPEN2_AUDEN 	|  	//Enable Audio mode
				SPI_OPEN2_IGNTUR 	|
				SPI_OPEN2_IGNROV 	|
				SPI_OPEN2_AUDMOD_I2S;	//Enable I2S mode
				

    
    //Configure and turn on the SPI1 module.  
    SpiChnOpenEx(SPI_CHANNEL1, spi_con1, spi_con2, (mclk/baud_rate));
    SPI1CONbits.STXISEL = 0b11;
	SPI1STATbits.SPIROV=0;
	tmp = SPI1BUF;
	SPI1STATbits.SPIROV=0;
	//Enable SPI1 interrupt.
    INTSetVectorPriority(INT_SPI_1_VECTOR, INT_PRIORITY_LEVEL_4);
    INTSetSubPriority(INT_SPI_1_VECTOR, INT_SUB_PRIORITY_LEVEL_0);  



	
	//Configure SPI in I2S mode with 24-bit stereo audio. 	
    spi_con1 = 	SPI_OPEN_MSTEN    	|  	//Master mode enable 
				SPI_OPEN_SSEN     	|  	//Enable slave select function
				SPI_OPEN_CKP_HIGH 	|  	//Clock polarity Idle High Actie Low
				SPI_OPEN_MODE16		|	//Data mode: 24b
				SPI_OPEN_MODE32		|	//Data mode: 24b
				SPI_OPEN_MCLKSEL	|	//Clock selected is reference clock
				SPI_OPEN_FSP_HIGH;   	//Frame Sync Pulse is active high

    spi_con2 = 	SPI_OPEN2_AUDEN 	|  	//Enable Audio mode
				SPI_OPEN2_IGNTUR 	|
				SPI_OPEN2_IGNROV 	|
				SPI_OPEN2_AUDMOD_I2S;	//Enable I2S mode
				

    
    //Configure and turn on the SPI1 module.  
    SpiChnOpenEx(SPI_CHANNEL2, spi_con1, spi_con2, (mclk/baud_rate));
    SPI2CONbits.STXISEL = 0b11;
	SPI2STATbits.SPIROV=0;
	tmp = SPI2BUF;
	SPI2STATbits.SPIROV=0;
	//Enable SPI1 interrupt.
    INTSetVectorPriority(INT_SPI_2_VECTOR, INT_PRIORITY_LEVEL_4);
    INTSetSubPriority(INT_SPI_2_VECTOR, INT_SUB_PRIORITY_LEVEL_0);  
	
	
}


